unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, WPFCOMService_TLB, Vcl.ExtCtrls;

type
  TMainForm = class(TForm)
    procedure FormActivate(Sender: TObject);
  private
    service: IWPFCOMService;
    thread: TThread;
    isMoving: Boolean;
    procedure WMEnterSizeMove(var Message: TMessage) ; message WM_ENTERSIZEMOVE;
    procedure WMMove(var Message: TMessage) ; message WM_MOVE;
    procedure WMExitSizeMove(var Message: TMessage) ; message WM_EXITSIZEMOVE;
    procedure PerformResize;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.FormActivate(Sender: TObject);
begin
  if (service = nil) then
    service := CoWPFCOMService_.Create();
  service.EmbedWPFWindow(Handle, ClientWidth, ClientHeight);
end;

procedure TMainForm.WMEnterSizeMove(var Message: TMessage) ;
begin
  thread := TThread.CreateAnonymousThread(
    procedure
    begin
      while (isMoving) do
      begin
        PerformResize;
        Sleep(10);
      end;
      PerformResize;
    end
  );
  isMoving := True;
  thread.Start;
end;

procedure TMainForm.WMMove(var Message: TMessage) ;
begin
  PerformResize;
end;

procedure TMainForm.WMExitSizeMove(var Message: TMessage) ;
begin
  isMoving := False;
end;

procedure TMainForm.PerformResize;
begin
  if (service = nil) then
    exit;
  service.WindowResized(ClientWidth, ClientHeight);
end;

end.
