﻿using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Windows;
using System.Windows.Interop;
using System.Windows.Threading;
using WPFApplication;

namespace WPFCOMService
{
    [Guid("264A4D5A-C680-486A-B1DD-C265EFA1C201")]
    [ClassInterface(ClassInterfaceType.None)]
    [ComVisible(true)]
    public sealed class WPFCOMService : IWPFCOMService
    {

        [DllImport("user32.dll")]
        static extern void ShowWindow(IntPtr hWnd, int nCmdShow);

        static EmbeddedUserControl UserControl;
        static IntPtr UserControlPointer;
        static Dispatcher UserInterfaceThread;

        public void EmbedWPFWindow(IntPtr pointer, int width, int height)
        {
            Debugger.Launch();
            UserControlPointer = pointer;
            UserControl = new EmbeddedUserControl
            {
                Width = width, 
                Height = height
            };
            UserControl.InitializeComponent();
            var param = new HwndSourceParameters
            {
                WindowStyle = 0x40000000 | 0x04000000 | 0x02000000, 
                ParentWindow = UserControlPointer
            };
            var hWndSource = new HwndSource(param)
            {
                SizeToContent = SizeToContent.WidthAndHeight, 
                RootVisual = UserControl
            };
            ShowWindow(hWndSource.Handle, 5);
            UserInterfaceThread = Dispatcher.CurrentDispatcher;
        }

        public void WindowResized(int width, int height)
        {
            UserInterfaceThread?.Invoke(() =>
            {
                UserControl.Width = width;
                UserControl.Height = height;
            });
        }
    }

    [ComVisible(true)]
    [Guid("06AD88DA-7BC3-4D3B-98E4-B383C7C55E38")]
    public interface IWPFCOMService
    {
        void EmbedWPFWindow(IntPtr pointer, int width, int height);
        void WindowResized(int width, int height);
    }
}
