﻿using System;
using System.Windows.Interop;
using System.Runtime.InteropServices;

namespace WPFApplication
{
    public class DelphiControlHost : HwndHost
    {

        [DllImport("user32.dll")]
        static extern IntPtr CreateWindowEx(int dwExStyle, string lpszClassName, string lpszWindowName, int style, int x, int y, int width, int height, IntPtr hWndParent, IntPtr hMenu, IntPtr hInstance, IntPtr lpParam);

        [DllImport("user32.dll")]
        static extern IntPtr SetParent(IntPtr hWndChild, IntPtr hWndNewParent);

        [DllImport("user32.dll")]
        static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

        [DllImport("user32.dll")]
        static extern bool DestroyWindow(IntPtr hWnd);

        int height;
        int width;
        IntPtr child;

        public DelphiControlHost(double initialWidth, double initialHeight, IntPtr hostedControl)
        {
            width = (int)initialWidth;
            height = (int)initialHeight;
            child = hostedControl;
        }

        protected override HandleRef BuildWindowCore(HandleRef hwndParent)
        {
            var host = CreateWindowEx(0, "static", null, 0x40000000 | 0x10000000, 0, 0, height, width, hwndParent.Handle, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
            SetParent(child, host);
            ShowWindow(child, 5);
            return new HandleRef(this, host);
        }

        protected override void DestroyWindowCore(HandleRef hwnd)
        {
            DestroyWindow(hwnd.Handle);
        }
    }
}
