﻿using System;
using System.Runtime.InteropServices;
using System.Windows;
using DelphiCOMService;

namespace WPFApplication
{
    public partial class MainWindow : Window
    {

        [DllImport("msvcr110.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int _fpreset();

        private DelphiCOMServiceImplementation service;

        public MainWindow()
        {
            _fpreset();
            InitializeComponent();
        }

        private void MainWindow_OnActivated(object sender, EventArgs e)
        {
            if (service != null)
                return;
            service = new DelphiCOMServiceImplementation();
            var control = service.GetDelphiFrame(DelphiHostElement.ActualWidth, DelphiHostElement.ActualHeight);
            DelphiHostElement.Child = new DelphiControlHost(DelphiHostElement.ActualWidth, DelphiHostElement.ActualHeight, control);
        }

        private void MainCanvas_OnSizeChanged(object sender, SizeChangedEventArgs e)
        {
            service?.WindowResized(DelphiHostElement.ActualWidth, DelphiHostElement.ActualHeight);
        }
    }
}
